Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Botan::Win32_EntropySource Class Referencefinal

`#include <es_win32.h>`

Inheritance diagram for Botan::Win32_EntropySource:

## Public Member Functions
std::string | name () const override
size_t | poll (RandomNumberGenerator &rng) override

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

Win32 Entropy Source

Definition at line 18 of file es_win32.h.

## Member Function Documentation

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static inherited

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 67 of file entropy_srcs.cpp.

References BOTAN_UNUSED, and Botan::OS::running_in_privileged_state().

Referenced by Botan::Entropy_Sources::Entropy_Sources().

68 {
69 #if defined(BOTAN_HAS_SYSTEM_RNG)
70 if(name == "system_rng" || name == "win32_cryptoapi")
71 {
72 return std::unique_ptr<Entropy_Source>(new System_RNG_EntropySource);
73 }
74 #endif
75
76 #if defined(BOTAN_HAS_ENTROPY_SRC_RDRAND)
77 if(name == "rdrand")
78 {
79 return std::unique_ptr<Entropy_Source>(new Intel_Rdrand);
80 }
81 #endif
82
83 #if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
84 if(name == "rdseed")
85 {
86 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
87 }
88 #endif
89
90 #if defined(BOTAN_HAS_ENTROPY_SRC_DARN)
91 if(name == "p9_darn")
92 {
93 return std::unique_ptr<Entropy_Source>(new POWER9_DARN);
94 }
95 #endif
96
97 #if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
98 if(name == "getentropy")
99 {
100 return std::unique_ptr<Entropy_Source>(new Getentropy);
101 }
102 #endif
103
104 #if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
105 if(name == "dev_random")
106 {
107 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
108 }
109 #endif
110
111 #if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
112 if(name == "proc_walk" && OS::running_in_privileged_state() == false)
113 {
114 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
115 if(!root_dir.empty())
116 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
117 }
118 #endif
119
120 #if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
121 if(name == "system_stats")
122 {
123 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
124 }
125 #endif
126
127 BOTAN_UNUSED(name);
128 return std::unique_ptr<Entropy_Source>();
129 }
Botan::Entropy_Source::name
virtual std::string name() const =0
Botan::OS::running_in_privileged_state
bool running_in_privileged_state()
Definition: os_utils.cpp:143
BOTAN_UNUSED
#define BOTAN_UNUSED(...)
Definition: assert.h:142

std::string Botan::Win32_EntropySource::name | ( |  | ) | const
| inline override virtual

Returns
  name identifying this entropy source

Implements Botan::Entropy_Source.

Definition at line 21 of file es_win32.h.

21 { return "system_stats"; }

size_t Botan::Win32_EntropySource::poll | ( | RandomNumberGenerator & | rng | ) |
| override virtual

Win32 poll using stats functions including Tooltip32

Implements Botan::Entropy_Source.

Definition at line 20 of file es_win32.cpp.

References Botan::RandomNumberGenerator::add_entropy_T(), and TOOLHELP32_ITER.

21 {
22 const size_t POLL_TARGET = 128;
23 const size_t EST_ENTROPY_HEAP_INFO = 4;
24 const size_t EST_ENTROPY_THREAD_INFO = 2;
25
26 /*
27 First query a bunch of basic statistical stuff
28 */
29 rng.add_entropy_T(::GetTickCount());
30 rng.add_entropy_T(::GetMessagePos());
31 rng.add_entropy_T(::GetMessageTime());
32 rng.add_entropy_T(::GetInputState());
33
34 rng.add_entropy_T(::GetCurrentProcessId());
35 rng.add_entropy_T(::GetCurrentThreadId());
36
37 SYSTEM_INFO sys_info;
38 ::GetSystemInfo(&sys_info);
39 rng.add_entropy_T(sys_info);
40
41 MEMORYSTATUSEX mem_info;
42 ::GlobalMemoryStatusEx(&mem_info);
43 rng.add_entropy_T(mem_info);
44
45 POINT point;
46 ::GetCursorPos(&point);
47 rng.add_entropy_T(point);
48
49 ::GetCaretPos(&point);
50 rng.add_entropy_T(point);
51
52 /*
53 Now use the Tooltip library to iterate through various objects on
54 the system, including processes, threads, and heap objects.
55 */
56
57 HANDLE snapshot = ::CreateToolhelp32Snapshot(TH32CS_SNAPALL, 0);
58 size_t collected = 0;
59
60 #define TOOLHELP32_ITER(DATA_TYPE, FUNC_FIRST, FUNC_NEXT) \
61 if(collected < POLL_TARGET) \
62 { \
63 DATA_TYPE info; \
64 info.dwSize = sizeof(DATA_TYPE); \
65 if(FUNC_FIRST(snapshot, &info)) \
66 { \
67 do \
68 { \
69 rng.add_entropy_T(info); \
70 collected += EST_ENTROPY_THREAD_INFO; \
71 if(collected >= POLL_TARGET) \
72 break; \
73 } while(FUNC_NEXT(snapshot, &info)); \
74 } \
75 }
76
77 TOOLHELP32_ITER(MODULEENTRY32, ::Module32First, ::Module32Next);
78 TOOLHELP32_ITER(PROCESSENTRY32, ::Process32First, ::Process32Next);
79 TOOLHELP32_ITER(THREADENTRY32, ::Thread32First, ::Thread32Next);
80
81 #undef TOOLHELP32_ITER
82
83 if(collected < POLL_TARGET)
84 {
85 HEAPLIST32 heap_list;
86 heap_list.dwSize = sizeof(HEAPLIST32);
87
88 if(::Heap32ListFirst(snapshot, &heap_list))
89 {
90 do
91 {
92 rng.add_entropy_T(heap_list);
93
94 HEAPENTRY32 heap_entry;
95 heap_entry.dwSize = sizeof(HEAPENTRY32);
96 if(::Heap32First(&heap_entry,
97 heap_list.th32ProcessID,
98 heap_list.th32HeapID))
99 {
100 do
101 {
102 rng.add_entropy_T(heap_entry);
103 collected += EST_ENTROPY_HEAP_INFO;
104 if(collected >= POLL_TARGET)
105 break;
106 } while(::Heap32Next(&heap_entry));
107 }
108
109 if(collected >= POLL_TARGET)
110 break;
111
112 } while(::Heap32ListNext(snapshot, &heap_list));
113 }
114 }
115
116 ::CloseHandle(snapshot);
117
118 return collected;
119 }
TOOLHELP32_ITER
#define TOOLHELP32_ITER(DATA_TYPE, FUNC_FIRST, FUNC_NEXT)

The documentation for this class was generated from the following files:

- src/lib/entropy/win32_stats/es_win32.h
- src/lib/entropy/win32_stats/es_win32.cpp